// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js

angular.module('OBApp', [
  'ionic',
  'chart.js',
  'highcharts-ng',
  'ngCordova',
  'ngMessages',
  'ngTouch',
  'ngRoute',
  'ngAnimate',
  'ngCookies',
  'OBApp.services',
  'OBApp.home',
  'OBApp.me',
  'OBApp.product',
  'OBApp.news',
  'OBApp.user',
  'OBApp.trade',
    'OBApp.share',
    'OBApp.finance'
])


   //.constant("HTTP_HOST", "http://112.74.135.208")//ali yun
  .constant("HTTP_HOST", "http://www.cntea168.com")//ali yun
 //.constant("HTTP_HOST", "http://10.0.1.123:8888")//localhost
 //      .constant("HTTP_HOST", "http://10.0.1.113:8888")//localhost

.config(function($ionicConfigProvider) {
  $ionicConfigProvider.tabs.position("bottom");
  $ionicConfigProvider.navBar.alignTitle("center");
  $ionicConfigProvider.tabs.style("standard");
  $ionicConfigProvider.views.swipeBackEnabled(false);
})

.config(function($ionicConfigProvider) {
  $ionicConfigProvider.backButton.text('返回');
})

.run(function($ionicPlatform, $cordovaStatusbar) {


  $ionicPlatform.ready(function() {
      $cordovaStatusbar.overlaysWebView(true);
      $cordovaStatusbar.styleColor('black');
      $cordovaStatusbar.style(1); //Black, opaque

    //jpush init
    try{
      window.plugins.jPushPlugin.init();
      if(device.platform != "Android"){
        window.plugins.jPushPlugin.setDebugModeFromIos();
        window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
        window.plugins.jPushPlugin.setDebugMode(false);
      }else{
        window.plugins.jPushPlugin.setDebugMode(false);
      }
    }
    catch(exception){
      console.log(exception);
    }
  });
})
.filter("sanitize", ['$sce', function($sce) {
    return function(htmlCode){
        return $sce.trustAsHtml(htmlCode);
    }
}])

.filter('percentage', ['$filter', function ($filter) {
  return function (input, decimals, sign) {
    if(angular.isNumber(input)){
      var prefix = sign ? (input > 0 ? "+" : "") : "";
      return prefix + $filter('number')(input * 100, decimals) + '%';
    }else{
      return "-";
    }

  };
}])

.filter('signNumber', ['$filter', function ($filter) {
  return function (number, fractionSize) {
    if(angular.isNumber(number)){
      var prefix = number > 0 ? "+" : "";
      return prefix + $filter('number')(number, fractionSize);
    }else{
      return "-";
    }

  };
}])

.filter('obDate', ['$filter', function ($filter) {
  return function (input,format) {
    var fmt = format || "yyyy-MM-dd HH:mm";
    return $filter('date')(input,fmt);
  };
}])
.filter('obDateString', ['$filter', function ($filter) {
  return function (input,format) {
    //20151229172838
    return moment(input, "YYYYMMDDhms").format(format);
  }
}])
.filter('teaCurrency', ['$filter', function ($filter) {
  return function (input) {
    if(input != "-"){
      return $filter('currency')(input,"",2);
    }else{
      return input;
    }
  };
}])

.filter('split', function() {
    return function(input, splitChar, splitIndex) {
        // do some bounds checking here to ensure it has that index
        return input.split(splitChar)[splitIndex];
    }
})

.run(function($ionicPlatform,$ionicHistory,$state,$timeout,$rootScope,$ionicPopup) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }
  });

  $ionicPlatform.registerBackButtonAction(function (event) {
      if($ionicHistory.currentStateName() == "tab.home"){
        $ionicPopup.confirm({
          title: "退出程序",
          buttons: [{
            text: '取消',
            type: 'button-default button-small',
            onTap: function(e) {
            }
          }, {
            text: '确认',
            type: 'button-assertive button-small',
            onTap: function(e) {
              ionic.Platform.exitApp();
            }
          }]
        });
      }else {
        if($ionicHistory.currentStateName() == "tab.me"
        || $ionicHistory.currentStateName() == "tab.productCategory"
        || $ionicHistory.currentStateName() == "tab.trade"
        || $ionicHistory.currentStateName() == "tab.financeCategory"
        || $ionicHistory.currentStateName() == "tab.trade.buyList"
        || $ionicHistory.currentStateName() == "tab.trade.sell"
        || $ionicHistory.currentStateName() == "tab.trade.order"){
          $state.go("tab.home");
        }else{
          $ionicHistory.goBack();
        }
      }

    }, 100);

})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
  .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'tabs.html'
  })

  // Each tab has its own nav history stack:
      .state('share', {
        url: '/share/product/{id}',
        cache:false,
        templateUrl: 'share/detail.html',
        controller: 'ProductShareController',
        resolve: {
          OpenCloseParams: function (TradeService) {
            return TradeService.getOpenAndCloseData().then(function (data) {
              return data;
            })
          },
          LimitPriceUpAndDown:function ($stateParams,TradeService) {
            return TradeService.queryLimitPriceUpAndDown($stateParams.id).then(function (data) {
              return data;
            })
          }
        }
      })
      .state('downloadApp', {
        url: '/downloadApp',
        cache:false,
        templateUrl: 'share/download.html',
        controller: 'ProductShareAppDownloadController'
      })


  // if none of the above states are matched, use this as the fallback
  //$urlRouterProvider.otherwise('/user/signIn');
      $urlRouterProvider.otherwise('/tab/home');
})
.directive('obSegement', function() {
  return {
    restrict: 'E',
    scope: {
      datas: '=',
      onSegChange: '&',
      ngModel: '='
    },
    link: function(scope, element, attrs) {
      scope.ngModel = scope.ngModel || scope.datas[0];
      scope.fuckHerBody = "her";

      scope.select = function(seg) {
        scope.ngModel = seg;
        scope.onSegChange({selectedSeg: seg});
      }
    },
    template: '<div class="row segement"><div class="col" ng-click="select(item)" ng-repeat="item in datas" ng-class="{\'active\': item.key == ngModel.key}">{{item.title}}</div></div>'
  };
})

.factory('DeviceService', ['$ionicPlatform','$cordovaImagePicker','$cordovaSocialSharing','$cordovaActionSheet','$cordovaDialogs',
  function ($ionicPlatform, $cordovaImagePicker,$cordovaSocialSharing,$cordovaActionSheet,$cordovaDialogs) {
  return {
    doOpenImagePicker : function(){
      console.log("function");
      var options = {
        maximumImagesCount: 10,
        width: 800,
        height: 800,
        quality: 80
      };
      $ionicPlatform.ready(function(){
        return $cordovaImagePicker.getPictures(options);
      });
    },
    doSocialShareViaSMS: function (message,number) {
      $ionicPlatform.ready(function(){
        return $cordovaSocialSharing
            .shareViaSMS(message, number);

      });
    },
    doShowAlertDialog: function (msssage) {
      return $cordovaDialogs.alert(msssage, '提示', '确认');
    },
    doShowActionSheet: function (title,buttonLabels) {
      var options = {
        title: title,
        buttonLabels: buttonLabels,
        addCancelButtonWithLabel: '取消',
        androidEnableCancelButton : true,
        winphoneEnableCancelButton : true
      };
      $ionicPlatform.ready(function(){
        return $cordovaActionSheet.show(options);
      });
    }
  };
}])

.factory('HTTPService', function ($http,$window,$q,$ionicLoading,$ionicPopup,HTTP_HOST,$rootScope) {
  return {
    doAction : function() {
      var url, data,needLoading;
      if(arguments.length <=1){
        return;
      }else if(arguments.length == 2){
        url = arguments[0];
        data = arguments[1];
        needLoading = true;
      }else if(arguments.length ==3){
        url = arguments[0];
        data = arguments[1];
        needLoading = arguments[2];
      }
      var deferred = $q.defer();
      data["token"] = $window.localStorage.token;
      data["channel"] = 2;
      if(needLoading){
        $ionicLoading.show({
          template: '加载中...',
          hideOnStateChange:true,
          duration:7000
        });
      }

      $http({
        method: 'POST',
        url: HTTP_HOST + url,//ali yun
        data: data
      }).success(function(data, status, headers, config) {
        if(needLoading){
          $ionicLoading.hide();
        }
        if(!data.status){
          if($rootScope.myAlert){
            $rootScope.myAlert.close();
          }
          $rootScope.myAlert = $ionicPopup.alert({
           title: '出错啦～',
           template: data.desc
         });
        }

        deferred.resolve(data);
      }).error(function(data, status, headers, config) {
        if(needLoading){
          $ionicLoading.hide();
        }
        if($rootScope.myAlert){
          $rootScope.myAlert.close();
        }
        $rootScope.myAlert = $ionicPopup.alert({
          title: status,
          template: "服务器错误",
          buttons:[{ text: '确定' }]

        });
        deferred.reject(data);
      });
      return deferred.promise;
    }
  };
})

.config(function($httpProvider) {
  $httpProvider.defaults.useXDomain = true;
  delete $httpProvider.defaults.headers.common['X-Requested-With'];
  $httpProvider.defaults.transformRequest = function(data) {
    var query = '', name, value;
    if (data instanceof Object) {

      for(key in data) {
        name = key;
        value = data[key];
        query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
      }
      return query;
    } else {
      return data;
    }
  };

  $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
})
.controller('MainController', function ($scope, $stateParams, $location, $ionicPopup, $timeout,$window,$rootScope,SignService,$ionicLoading,$ionicPlatform,$document) {
  $scope.showConfirmMessage =  function (title, fnCallback,okText,$state) {
    $ionicPopup.show({
      title: title,
      buttons: [{
        text: '取消',
        type: 'button-default',
        onTap: function(e) {
        }
      }, {
        text: okText ? okText : "确定",
        type: 'button-energized',
        onTap: function(e) {
          if(angular.isFunction(fnCallback)){
            fnCallback();
          }
        }
      }]
    })
  }

  $scope.doNotificationAction = function (data,needShowConfirm) {
    $ionicPlatform.ready(function () {
      if(device.platform !== "Android"){
        window.plugins.jPushPlugin.resetBadge();
      }

      //if(data == -1){
      //  $scope.showConfirmMessage(data.title, function () {
      //  },"确定");
      //  return;
      //}
      if(needShowConfirm){
        $scope.showConfirmMessage(data.title, function () {
          $location.url("tab/home/contentList/BUSINESSAD/交易公告");

        }, "查看");
      }else{
        $ionicLoading.show({
          template: "加载中..."
        });
        $timeout(function () {
          $ionicLoading.hide();
          $location.url("tab/home/contentList/BUSINESSAD/交易公告");
        },800);
      }
    });
  }
  //jpush 事件
  $document.bind("jpush.openNotification", function (event) {
    try{
      var alertContent;
      var data = {};
      data.type = "Project";
      if(device.platform == "Android"){
        alertContent=window.plugins.jPushPlugin.openNotification;
        data.title = alertContent.alert;
        //if(alertContent.extras["cn.jpush.android.EXTRA"].projectId){
        //  data.id = alertContent.extras["cn.jpush.android.EXTRA"].projectId;
        //}else{
        //  data.id = -1;
        //}
      }else{
        data.title = event.aps.alert;
        //if(event.projectId){
        //  data.id = event.projectId;
        //}else{
        //  data.id = -1;
        //
        //}
      }
      $scope.doNotificationAction(data,false);
    }
    catch(exception){
      console.log("JPushPlugin:onOpenNotification"+exception);
    }
  })

  $document.bind("jpush.receiveNotification", function (event) {
    try{
      var alertContent;
      var data = {};
      data.type = "Project";
      if(device.platform == "Android"){
        alertContent = window.plugins.jPushPlugin.receiveNotification;
        data.title = alertContent.alert;
        //if(alertContent.extras["cn.jpush.android.EXTRA"].projectId){
        //  data.id = alertContent.extras["cn.jpush.android.EXTRA"].projectId;
        //}else{
        //  data.id = -1;
        //}
      }else{
        data.title = event.aps.alert;
        //if(event.projectId){
        //  data.id = event.projectId;
        //}else{
        //  data.id = -1;
        //
        //}
      }
      $scope.doNotificationAction(data,true);
    }
    catch(exeption){
      console.log(exception)
    }
  })

      $scope.gotoMobileShop = function () {

        if(!SignService.userLogined()){
          $state.go("tab.me");
          return;
        }
        youzan.showMall({uid:SignService.getUserName(),userName:SignService.getUserName()},function(msg){},function(){});
      }
   $scope.tabClick = function () {
     $scope.gotoMobileShop();
   }
});





