
angular.module('OBApp.home', [
  'angular-carousel'
])

.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider
  .state('tab.home', {
    url: '/home',
    views: {
      'tab-home': {
        templateUrl: 'home/index.html',
        controller: 'HomeController'
      }
    }
  })
  .state('tab.homeContent', {
      url: '/home/content/{contentKey}',
      views: {
          'tab-home': {
              templateUrl: 'news/detail.html',
              controller: 'HomeContentController'
          }
      }
  })
  .state('tab.homeContentList', {
      url: '/home/contentList/{contentKey}/{name}',
      views: {
          'tab-home': {
              templateUrl: 'home/contentList.html',
              controller: 'HomeContentLstController'
          }
      }
  })
  .state('tab.homeContentDetail', {
      url: '/home/ContentDetail/:id/:contentKey',
      views: {
          'tab-home': {
              templateUrl: 'news/detail.html',
              controller: 'HomeContentDetailController'
          }
      }
  })
})

.controller('HomeController', function ($scope, ContentService,TradeService,SignService,$location,$state) {
    ContentService.queryContentsByType("SLIDE").then(function (data) {
        $scope.slides =[];
        angular.forEach(data, function(obj, index) {
            $scope.slides.push({id:obj.id,image:obj.imagePrefix + obj.imageUrl});
        });
    });
        //$scope.gotoMobileShop = function () {
        //    var url = "https://wap.koudaitong.com/v2/home/bmu8siou";
        //    $scope.ref = cordova.InAppBrowser.open(url, '_self', 'location=yes,clearcache=yes,clearsessioncache=yes,hardwareback=yes,closebuttoncaption=完成');
        //    $scope.ref.addEventListener('exit', function(event) {
        //    });
        //}
        $scope.gotoMobileShop = function () {
            if(!SignService.userLogined()){
                $state.go("tab.me");
                return;
            }
            youzan.showMall({uid:SignService.getUserName(),userName:SignService.getUserName()},function(msg){},function(){});
        }

        $scope.action = function (item) {
            if(item.id != 2){
                $location.url(item.url);
            }else{
                $scope.gotoMobileShop();
            }
        }
    //TradeService.queryLatestTradeInfo().then(function (data) {
    //    $scope.liveMessage = data;
    //});
    //if(SignService.userLogined()){
        $scope.featureList = [
            { id: 1 , icon:"home-icon-1", style:"royal", title:"交易公告", url: "tab/home/contentList/BUSINESSAD/交易公告" },
            //{ id: 2 , icon:"ion-arrow-graph-up-right", style:"assertive", title:"行情指数", url: "tab/product?key=code"},
            { id: 2 , icon:"home-icon-2", style:"dark", title:"我要买茶", url: "tab/product" },
            { id: 3 , icon:"home-icon-3", style:"assertive", title:"行情指数", url: "tab/financeCategory"},

            { id: 4 , icon:"home-icon-4", style:"balanced", title:"上市品种", url: "tab/home/contentList/INTRODUCTION/上市品种"},
            { id: 5 , icon:"home-icon-5", style:"royal", title:"行业资讯", url: "tab/home/contentList/TEA_NEWS/行业资讯"},
            { id: 6 , icon:"home-icon-6", style:"dark", title:"白茶课堂", url: "tab/home/contentList/TEA_LESSON/白茶课堂"},
            { id: 7 , icon:"home-icon-7", style:"balanced", title:"交易指南", url: "tab/home/contentList/OPENFLOW/交易指南"},

            { id: 8 , icon:"home-icon-8", style:"calm", title:"合作商家", url: "tab/home/contentList/JOINUS/合作商家"},
            { id: 9 , icon:"home-icon-9", style:"positive", title:"关于我们", url: "tab/home/content/ABOUTUS"}
        ];
    //}

})
.controller('HomeContentController', function ($scope,$stateParams, ContentService) {
  var  type = $stateParams.contentKey;
  if(type == "INTRODUCTION"){
    $scope.title = "上市品种";
  }else if(type == "JOINUS"){
      $scope.title = "合作商家";
  }else if(type == "ABOUTUS"){
      $scope.title = "关于我们";
  }else{
      $scope.title = "内容";
  }
  ContentService.queryContentsByType(type).then(function (data) {
      $scope.newsItem = data[0];
  });
})

.controller('HomeContentLstController', function ($scope,$stateParams, ContentService) {
    $scope.title = $stateParams.name;
    ContentService.queryContentsByType($stateParams.contentKey).then(function (data) {
        $scope.data = data;
    });
})

.controller('HomeContentDetailController', function ($scope,$stateParams, ContentService) {
    $scope.title = $stateParams.contentKey;
    ContentService.queryContentById($stateParams.id).then(function (data) {
        $scope.newsItem = data[0];
    });
})




