
angular.module('OBApp.services', [])

    .factory('SignService', ['HTTPService','$window','$location','$q', function (HTTPService,$window,$location,$q) {
      return {
        signIn : function(userName, password,ipAddress) {
          return HTTPService.doAction('/api/iUser.php',{
            action: "signIn",
            module: "teaSignService",
            userName: userName,
            password: password,
            idAddress:ipAddress
          }).then(function(data){
            if (data.status) {
              if($window.localStorage.token){
                $window.localStorage.removeItem("token");
              }
              $window.localStorage.token = data.desc;
              if($window.localStorage.userName){
                $window.localStorage.removeItem("userName");
              }
              $window.localStorage.userName = userName;

              if($window.localStorage.password){
                $window.localStorage.removeItem("password");
              }
              $window.localStorage.password = password;

              if($window.localStorage.userId){
                $window.localStorage.removeItem("userId");
              }
              $window.localStorage.userId = data.data.id;

            }else{
              if($window.localStorage.token)
                $window.localStorage.removeItem("token");
              if($window.localStorage.userName)
                $window.localStorage.removeItem("userName");
              if($window.localStorage.password)
                $window.localStorage.removeItem("password");
              if($window.localStorage.userId)
                $window.localStorage.removeItem("userId");
              if($window.localStorage.siginedUser)
                $window.localStorage.removeItem("siginedUser");
            }
            return data;
          });
        },
        signUp: function (p) {
          p.module = "teaSignService";
          p.action = "signUp";
          return HTTPService.doAction('/api/iUser.php', p).then(function(data){
            if (data.status) {
              var u = data.data[0];

              if($window.localStorage.token){
                $window.localStorage.removeItem("token");
              }
              $window.localStorage.token = data.desc;

              if($window.localStorage.userName){
                $window.localStorage.removeItem("userName");
              }
              $window.localStorage.userName = p.userName;

              if($window.localStorage.password){
                $window.localStorage.removeItem("password");
              }
              $window.localStorage.password = p.password;

              if($window.localStorage.userId){
                $window.localStorage.removeItem("userId");
              }
              $window.localStorage.userId = u.id;

            }
            return data;

          });
        },
        userLogined : function() {
          return $window.localStorage.userName && $window.localStorage.password;
        },
        modifyPassword: function (uid,password,newPassword) {
          return HTTPService.doAction('/api/iUser.php', {
            action: 'modifyPassword',
            module: "teaSignService",
            uid:uid,
            oldPassword:password,
            password:newPassword
          });
        },
        resetPassword: function (userName,password) {
          return HTTPService.doAction('/api/iUser.php', {
            action: 'resetPassword',
            module: "teaSignService",
            userName:userName,
            password:password
          });
        },
        signOut : function(){

          if($window.localStorage.token)
            $window.localStorage.removeItem("token");
          if($window.localStorage.userName)
            $window.localStorage.removeItem("userName");
          if($window.localStorage.password)
            $window.localStorage.removeItem("password");
          if($window.localStorage.userId)
            $window.localStorage.removeItem("userId");
          if($window.localStorage.siginedUser)
            $window.localStorage.removeItem("siginedUser");

          $location.path("user/signIn");
        },
        getUserName : function(){
          return $window.localStorage.userName;
        },
        getUserId : function(){
          return $window.localStorage.userId;
        },
        getPassword : function(){
          return $window.localStorage.password;
        },
        getToken : function(){
          return $window.localStorage.token;
        },
        getSignedUser: function (config) {
          // if (!cache) {
          //   cache = true;//默认为true
          // }
          config = config || {
                cache : true,
                needLoading : true
              };

          if(config.cache && $window.localStorage.siginedUser){
            var deferred = $q.defer();//一定要这样写，不然调用的时候会出错
            var d = angular.fromJson($window.localStorage.siginedUser);
            deferred.resolve(d);
            return deferred.promise;
          }else{
            return  HTTPService.doAction('/api/iUser.php',{
              action : 'queryUserInfo',
              module: "teaSignService",
              userName : this.getUserName()
            },config.needLoading).then(function(data) {
              if (data.status) {
                $window.localStorage.siginedUser = angular.toJson(data.data);
                return data.data;
              }
            });
          }
        }
      };
    }])

.factory('ProductService', function ($http, $q, $cookieStore, $location, $state,HTTPService) {
  return {
    getProductList : function() {
      p = {};
      p.module = "teaProductService";
      p.action = "queryProducts";
      return HTTPService.doAction('/api/iUser.php',p).then(function (data) {
        return data.data;
      });
    },

    getProductListWithCategory : function(category) {
      p = {};
      p.module = "teaProductService";
      p.action = "queryProducts";
      p.category = category;
      return HTTPService.doAction('/api/iUser.php',p).then(function (data) {
        return data.data;
      });
    },
    getProductDetail : function(productId) {
      p = {};
      p.module = "teaProductService";
      p.action = "queryProductById";
      p.id = productId;
      return HTTPService.doAction('/api/iUser.php',p).then(function (data) {
        return data.data;
      });
    },
    getProductCategory: function () {
      p = {};
      p.module = "teaConfigService";
      p.action = "queryDictValuesByParentKey";
      p.parentKey = "PRODUCT_CATEGORY";

      return HTTPService.doAction('/api/iUser.php',p).then(function (data) {
        return data.data;
      });
    },
    orderProducts: function (name,orderType,category) {
      p = {};
      p.module = "teaProductService";
      p.action = "queryProductsViaOrders";
      p.orderType = orderType;

      if(category == undefined || category == '' || category == null){
        p.category = '';
      }else{
        p.category = category;
      }
      if(name == undefined || name == '' || name == null){
        p.name = '';
      }else{
        p.name = name;
      }

      return HTTPService.doAction('/api/iUser.php',p).then(function (data) {
        return data.data;
      });
    }

  };  
})

.factory('ContentService', function (HTTPService) {
  return {
    queryContentsByType: function (type) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryContentsByType',
        module:"teaContentService",
        type:type
      }).then(function(data){
        return data.data;
      });
    },
    queryContentById: function (id) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryContentById',
        module:"teaContentService",
        id:id
      }).then(function(data){
        return data.data;
      });
    }

  };
})

.factory('FavouriteService', function (HTTPService) {
  return {
    addFavourite: function (uid,tid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'addFavourite',
        module:"teaFavouriteService",
        id:uid,
        tid:tid
      }).then(function(data){
        return data;
      });
    },
    getUserFavouriteProductList: function (id) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'getUserFavouriteProductList',
        module:"teaFavouriteService",
        id:id
      }).then(function(data){
        return data.data;
      });
    },
    isMyFavourite: function (uid,tid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'isMyFavourite',
        module:"teaFavouriteService",
        id:uid,
        tid:tid,
      }).then(function(data){
        return data.data;
      });
    }


  };
})

.factory('VerifyCodeService', function (HTTPService) {
  return {
    signUpVerifyCode: function (mobile) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'signUpVerifyCode',
        module:"obVerifyCodeService",
        mobile:mobile
      }).then(function(data){
        return data;
      });
    },
    forgetPasswordVerifyCode: function (mobile) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'forgetPasswordVerifyCode',
        module:"obVerifyCodeService",
        mobile:mobile
      }).then(function(data){
        return data;
      });
    },
    checkVerifyCodeAction: function (mobile,code) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'checkVerifyCodeAction',
        module:"obVerifyCodeService",
        mobile:mobile,
        code:code
      }).then(function(data){
        return data;
      });
    },

  };
})

.factory('TradeService', function ($http, $q,$filter, SignService, HTTPService) {
  return {
    getOrderList : function(id) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryOrderList',
        module:"teaTradeService",
        id :id
      }).then(function(data){
        return data.data;
      });

    },
    getUserOwnProductList : function(id) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'getUserOwnProductList',
        module:"teaTradeService",
        id :id
      }).then(function(data){
        return data.data;
      });

    },
    buyProduct : function(productId, amount, price,uid,address,phone,name) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'addOrder',
        module:"teaTradeService",
        uid :uid,
        tid:productId,
        amount:amount,
        price:price,
        type:"BUY",
        address:address,
        phone:phone,
        name:name

      }).then(function(data){
        return data;
      });
    },
    sellProduct : function(productId, amount, price,uid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'addOrder',
        module:"teaTradeService",
        uid :uid,
        tid:productId,
        amount:amount,
        price:price,
        type:"SELL"
      }).then(function(data){
        return data;
      });
    },

    cancelOrder : function(orderId,uid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'cancelOrder',
        module:"teaTradeService",
        uid :uid,
        oid:orderId
      }).then(function(data){
        return data;
      });
    },
    queryLatestTradeInfo: function () {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryLatestTradeInfo',
        module:"teaTradeService"
      }).then(function(data){
        return data.data.message;
      });
    },
    queryTradeList: function () {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryTradeList',
        module:"teaTradeService",
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    getMoneyLogs: function (uid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryMoneyLog',
        module:"teaTradeService",
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    getProductProfit: function (uid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryProductProfit',
        module:"teaTradeService",
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    moneyAction: function (p) {
      p.module = "teaTradeService";
      p.action = "moneyAction";
      p.uid = SignService.getUserId();
      return HTTPService.doAction('/api/iUser.php',p);
    },

    getUserCapatial: function () {

      return HTTPService.doAction('/api/iUser.php',{
        action:'queryUserCapatial',
        module:"teaTradeService",
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    queryCurrentDayData: function () {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryCurrentDayData',
        module:"teaTradeService"
      }).then(function(data){
        return data.data;
      });
    },
    queryUserPayInfo: function (uid,type) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryUserPayInfo',
        module:"teaTradeService",
        uid:uid,
        type:type
      }).then(function(data){
        return data;
      });
    },

    queryUserContactInfo:function (uid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryUserContactInfo',
        module:"teaProductService",
        uid:uid,
      }).then(function(data){
        return data;
      });
    },
    saveUserPayInfo: function (uid,card_number,bank_name,address,realName,type) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'saveUserPayInfo',
        module:"teaTradeService",
        uid:uid,
        card_number : card_number,
        bank_name :bank_name,
        realName:realName,
        type:type,
        address:address
      }).then(function(data){
        return data;
      });
    },

    queryChartData: function (p) {
      var simpleDelay = 15;
      var step = 1;
      if(angular.isDefined(p.interval)){
        step = p.interval;
      }
      if(angular.isDefined(p.sampling)){
        simpleDelay = p.sampling;
      }
      var labels = [];

      var millisecondOfDay = 24 * 60 * 60 * 1000;
      var now = new Date();
      var beginDate = new Date(now.getTime() - millisecondOfDay * (step -1));
      var endDate = new Date(now.getTime() +  millisecondOfDay);
      var sBeginDate =  $filter('date')(beginDate,"yyyy-MM-dd");
      var sEndDate = $filter('date')(endDate,"yyyy-MM-dd");

      p.module = "teaTradeService";
      p.action = "queryChartData";
      p.start = sBeginDate,
      p.end = sEndDate,
      p.uid = SignService.getUserId();

      return HTTPService.doAction('/api/iUser.php',p).then(function(data){
        var chart = {};
        chart.data = [];
        chart.labels = [];
        if(data.status){
          var values = data.data;
          for(var i = 0;i<values.length;i++){
            //var date = new Date(values[i].time);
            //moment.utc
            var date = moment.utc(values[i].time, "YYYY-MM-DD HH:mm:ss");
            //var utc = Date.UTC(date.getFullYear(),date.getMonth(),date.getDate(),date.getHours(),date.getMinutes(),date.getSeconds());
            chart.data.push({name:values[i].time,y:values[i].price,x:date});
          }
        }
        return chart;
      });
    },
    getOpenAndCloseData: function () {
      return HTTPService.doAction('/api/iUser.php',{
        action:'getOpenAndCloseData',
        module:"teaConfigService",
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    queryLimitPriceUpAndDown: function (tid) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryLimitPriceUpAndDown',
        module:"teaProductService",
        tid:tid,
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    queryPromotionList: function () {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryPromotionList',
        module:"teaTradeService",
        uid:SignService.getUserId()
      }).then(function(data){
        return data.data;
      });
    },
    saveDeliveryOrder: function (uid,tid,amount,address) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'saveDeliveryOrder',
        module:"teaTradeService",
        uid:uid,
        tid:tid,
        amount:amount,
        address:address
      }).then(function(data){
        return data;
      });
    }

  };  
})

.factory('obPayService', function (HTTPService, $q, SignService) {
  return {
    queryChargeOrders: function (query) {
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryChargeOrders',
        uid:SignService.getUserId(),
        module:"obPayService",
        query:query
      }).then(function(data){
        return data.data;
      });
    },
    queryWithdrawalOrders: function(query){
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryWithdrawalOrders',
        uid:SignService.getUserId(),
        module:"obPayService",
        query:query
      }).then(function(data){
        return data.data;
      });
    },
    queryOrderDetail: function(orderNo){
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryOrderDetail',
        uid:SignService.getUserId(),
        module:"obPayService",
        orderNo:orderNo
      }).then(function(data){
        return data.data;
      });
    },
    updateWithdrawalOrderStatus: function(orderNo,status){
      return HTTPService.doAction('/api/iUser.php',{
        action:'updateWithdrawalOrderStatus',
        uid:SignService.getUserId(),
        module:"obPayService",
        status:status,
        orderNo:orderNo
      }).then(function(data){
        return data;
      });
    },
    queryOrderByUser: function(){
      return HTTPService.doAction('/api/iUser.php',{
        action:'queryOrderByUser',
        uid:SignService.getUserId(),
        module:"obPayService"
      }).then(function(data){
        return data;
      });
    },
  };
})

.factory('IpService', function ($q,HTTP_HOST) {
  return {
    queryIpAddress: function () {
      var deferred = $q.defer();
      $.getJSON("http://ip-api.com/json/?callback=?", function(data) {
        deferred.resolve(data);
      }).fail(function() {
        deferred.resolve(null);
          });
      return deferred.promise;
    }
  };
})


