
angular.module('OBApp.share', [

])


.controller('ProductShareAppDownloadController', function ($scope, $filter, $stateParams, $location, ProductService, TradeService,FavouriteService,SignService,$ionicActionSheet) {

})
.controller('ProductShareController', function ($scope, $filter, $stateParams, $location, ProductService, TradeService,FavouriteService,SignService,$ionicActionSheet,OpenCloseParams,LimitPriceUpAndDown) {
    $scope.f = {};
        $scope.LimitPriceUpAndDown = LimitPriceUpAndDown;
        $scope.chartConfig = {
            options: {
                legend:{
                    enabled:false
                },
                plotOptions:{
                    spline:{
                        allowPointSelect:false
                    },
                    series: {
                        marker: {
                            enabled: false
                        }
                    }
                },
                tooltip: {
                    style: {
                        padding: 10,
                        fontWeight: 'bold'
                    }
                },
            },
            title: {
                text: ''
            },

            series: [],
            xAxis: {
            },
            yAxis:{
                title:''
            },
            size:{
                height:200
            }
        };
    $scope.productSegements = [
        { title: '行情', key:'market'},
        { title: '产品详情', key:'detail'}
    ];
    $scope.activeProductSegement = $scope.productSegements[0];

    $scope.productSegementChanged = function (selectedSeg) {
        $scope.activeProductSegement = selectedSeg;
    }
    $scope.modal = null;
    $scope.f.id = $stateParams.id;

    $scope.loadChartData = function (params) {
        if(angular.isUndefined(params.interval)){

            var date = new Date();
            var minValue = Date.UTC(date.getFullYear(),date.getMonth(),date.getDate(),parseInt(OpenCloseParams.start),0,0);
            $scope.chartConfig.yAxis = {};
            $scope.chartConfig.yAxis.title = "";
            $scope.chartConfig.yAxis.min = $scope.LimitPriceUpAndDown.down;
            $scope.chartConfig.yAxis.max = $scope.LimitPriceUpAndDown.up;

            $scope.chartConfig.yAxis.plotLines = [{
                color:'#DAA520',           //线的颜色
                dashStyle:'shortdash',     //虚线
                value:$scope.productDetail.priceLastDayFinish,               //昨日收盘价
                width:2                //线的宽度
            }];
            $scope.chartConfig.xAxis = {};
            $scope.chartConfig.xAxis = {
                type: 'datetime',
                min: minValue,
                startOnTick: true,
                tickInterval:600000,
                dateTimeLabelFormats :  {
                    second: '%Y-%m-%d<br/>%H:%M:%S'
                }
            }
        }else{
            $scope.chartConfig.xAxis = {};
            $scope.chartConfig.yAxis = {};
            $scope.chartConfig.yAxis.title = "";
            $scope.chartConfig.yAxis.min =null;
            $scope.chartConfig.yAxis.max = null;

            $scope.chartConfig.yAxis.plotLines = [];
            $scope.chartConfig.xAxis = {
                type: 'datetime',
                min:null,
                tickInterval:null,
                startOnTick:false,
                dateTimeLabelFormats:{
                    day: '%m-%d',
                    week: '%m-%d',
                    month: '%Y-%m',
                    year: '%Y'
                }
            }
        }

        TradeService.queryChartData(params).then(function(chart){
            $scope.chartConfig.series = [];
            var tmp  = {id:0,type: "spline",data:chart.data,name:$scope.productDetail.name};
            $scope.chartConfig.series.push(tmp);
        });
    }


    $scope.id = $stateParams.id;
    ProductService.getProductDetail($scope.id).then(function(productDetail){
      $scope.productDetail = productDetail;
      $scope.loadChartData($scope.f);
      TradeService.queryCurrentDayData().then(function(data){
        angular.forEach(data, function(tradeData, key) {
          if($scope.productDetail.id == tradeData.teaId){
            $scope.productDetail.tradeData = tradeData;
          }
        });
      });
    });

    $scope.productActions = [
      { title: '查看商品简介', url:'viewDesc' },
      { title: '查看我的交易明细', url:'viewTrades' }
    ];

    $scope.show5Days = function () {
      $scope.loadChartData({id:$stateParams.id,interval:5,sampling:180})
    }
    
    $scope.showMonth = function () {
      $scope.loadChartData({id:$stateParams.id,interval:30,sampling:240})
    }

    $scope.showToday = function () {
      $scope.loadChartData($scope.f);
    }
})

