
angular.module('OBApp.trade', [

])

.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider
  .state('tab.trade', {
    url: '/trade?:from',
    cache:false,
    views: {
      'tab-trade': {
        templateUrl: 'trade/index.html',
        controller: 'TradeIndexController'
      }
    }
  })

  .state('tab.tradeBuy', {
    url: '/trade/buy/{id:int}?:from',
    cache:false,

   views: {
      'tab-trade': {
          templateUrl: 'trade/buy.html',
          controller: 'TradeBuyController'
      }
    },
    resolve:{
        userCapatial: function (TradeService) {
            return TradeService.getUserCapatial().then(function(data){
                return data;
            });
        },
        userData: function (TradeService,SignService) {
            return TradeService.queryUserContactInfo(SignService.getUserId()).then(function(data){
                return data.data;
            });
        }

    }
  })

  .state('tab.tradeSell', {
    url: '/trade/sell/{id:int}',
    cache:false,
    views:{
        'tab-trade':{
            templateUrl: 'trade/sell.html',
            controller: 'TradeSellController'
        }
    },
    resolve:{
       ownProductList: function(TradeService, SignService){
          return TradeService.getUserOwnProductList(SignService.getUserId());
       }
    },
  })
})
.controller('TradeIndexController', function ($scope, $stateParams,$location, TradeService, ProductService,FavouriteService,SignService,$state,$ionicPopup,$filter) {

    if(!SignService.userLogined()){
        $state.go("tab.me");
        return;
    }

    $scope.segements = [
      { title: '我的自选', key:'buy'},
      { title: '我的持仓', key:'sell'},
      { title: '我的委托', key:'order'}
    ];
    if($stateParams.from){
        $scope.activeSegement = $filter('filter')($scope.segements,{key:$stateParams.from},false)[0];
    }else{
        $scope.activeSegement = $scope.segements[0];
    }

    $scope.segementChanged = function(selectedSeg){
        $scope.activeSegement = selectedSeg;
        $scope.loadData();
    }
        
    $scope.loadData = function () {
        if($scope.activeSegement.key == 'buy'){
            FavouriteService.getUserFavouriteProductList(SignService.getUserId()).then(function (data) {
                $scope.data = data;
            });
        }
        if($scope.activeSegement.key == 'sell'){
            TradeService.getUserOwnProductList(SignService.getUserId()).then(function (data) {
                $scope.data = data;
            });
        }
        if($scope.activeSegement.key == 'order'){
            TradeService.getOrderList(SignService.getUserId()).then(function(data){
                $scope.data = data;
            });
        }
    }
    $scope.loadData();

    $scope.cancelOrder = function (item) {
        if(item.canCancel == false)
            return;
        var myPopup = $ionicPopup.show({

            template: '<label>取消' + item.product.name + item.amount +  'KG 订单 ?</label>',
            title: '提示',
            scope: $scope,
            buttons: [
                {
                    text: '返回',
                    type: 'button-default',
                    onTap: function(e) {
                        return -1;
                    }
                },
                {
                    text: '<b>取消订单</b>',
                    type: 'button-energized',
                    onTap: function(e) {
                        return 0;
                    }
                }
            ]
        });
        myPopup.then(function(index) {
            if(index != -1){
                TradeService.cancelOrder(item.id,SignService.getUserId()).then(function(data){
                    if(data.status){
                        TradeService.getOrderList(SignService.getUserId()).then(function(data){
                            $scope.data = data;
                        })
                    }else{
                        $ionicPopup.alert({
                            title: '提示',
                            template: data.desc,
                            buttons:[{ text: '确定' }]
                        });
                    }
                });
            }
        });
    }
})

.controller('TradeBuyController', function ($scope, $stateParams,$location, ProductService,TradeService,SignService,$ionicPopup,userCapatial,$state,userData) {
    $scope.f = {};
    $scope.f.totalMoney = userCapatial.totalMoney;
    ProductService.getProductDetail($stateParams.id).then(function(data){
      $scope.productDetail = data;
      $scope.f.price = $scope.productDetail.price;
      $scope.f.address=   userData.address ? userData.address : "";
        $scope.f.realName=   userData.realName ? userData.realName : "";
        $scope.f.phone=   userData.phone ? userData.phone : "";

    });
   
    $scope.buyProduct = function () {
        $ionicPopup.confirm({
            title: "确认买入?",
            buttons: [{
                text: '取消',
                type: 'button-default button-small',
                onTap: function(e) {
                }
            }, {
                text: '确认',
                type: 'button-assertive button-small',
                onTap: function(e) {
                    var totalMoney = $scope.f.amount *  $scope.f.price;
                    if(totalMoney >= $scope.f.totalMoney){
                        $ionicPopup.alert({title:"成交金额大于账户余额,请先充值",buttons:[{ text: '确定' }]});
                        return;
                    }
                    if(SignService.userLogined()){
                        TradeService.buyProduct($scope.productDetail.id,$scope.f.amount,$scope.f.price,SignService.getUserId(),$scope.f.address,$scope.f.phone,$scope.f.realName).then(function (data) {
                            if(data.status){
                                $state.go("tab.trade",{from:"order"});
                                //if($stateParams.from == 'trade'){
                                //    $state.go("tab.trade",{from:"order"});
                                //}else{
                                //    $state.go("tab.productDetail",{id:$scope.productDetail.id});
                                //}
                            }else{
                                $ionicPopup.alert({
                                    title: '下单失败',
                                    template: data.desc,
                                    buttons:[{ text: '确定' }]
                                });
                            }
                        })
                    }
                }
            }]
        });
    }
})

.controller('TradeSellController', function ($scope, $stateParams,$location, ProductService, TradeService,SignService, ownProductList,$rootScope,$ionicPopup,$filter,$state) {
    $scope.f = {};

    $scope.selectedProduct = $filter('filter')(ownProductList, {teaid:$stateParams.id}, false)[0];

    $scope.back = function(){
      $scope.selectedProduct = null;
    }

    $scope.selectProduct = function(item){
      $scope.selectedProduct = item;
    }
    $scope.sellProduct = function () {
        $ionicPopup.confirm({
            title: "确认卖出?",
            buttons: [{
                text: '取消',
                type: 'button-default button-small',
                onTap: function(e) {
                }
            }, {
                text: '确认',
                type: 'button-assertive button-small',
                onTap: function(e) {
                    if(SignService.userLogined()){
                        TradeService.sellProduct($scope.selectedProduct.product.id,$scope.f.amount,$scope.f.price,SignService.getUserId()).then(function (data) {
                            if(data.status){
                                $state.go("tab.trade",{from:"order"});
                            }else{
                                $ionicPopup.alert({
                                    title: '下单失败',
                                    template: data.desc,
                                    buttons:[{ text: '确定' }]
                                });
                            }
                        })
                    }
                }
            }]
        });
    }        

})


