
angular.module('OBApp.user', [
  'ngCookies'
])

.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider
  .state('userSignIn', {
    url: '/user/signIn',
    templateUrl: 'user/signIn.html',
    controller: 'UserSignInController',
        resolve:{
          ipInfo: function (IpService) {
            //return IpService.queryIpAddress().then(function(data){
            //  return data;
            //});
            return {query:"192.168.1.1"};
          }
        }
  })

  .state('userSignUp', {
    url: '/user/signUp?inviter',
    templateUrl: 'user/signUp.html',
    controller: 'UserSignUpController',
      resolve:{
        ipInfo: function (IpService) {
          //return IpService.queryIpAddress().then(function(data){
          //  return data;
          //});
          return {query:"192.168.1.1"};

        }
      }
  })

  .state('userSignUpById', {
    url: '/user/signUp/:userType/:organizationId',
    templateUrl: 'user/signUp.html',
    controller: 'UserSignUpController',
        resolve:{
          ipInfo: function (IpService) {
            //return IpService.queryIpAddress().then(function(data){
            //  return data;
            //});
            return {query:"192.168.1.1"};

          }
        }
  })

  .state('signUpSuccess', {
    url: '/user/signUpSuccess',
    templateUrl: 'user/signUpSuccess.html',
    controller: 'UserSignUpDoneController'
  })
  .state('signUpSuccessAndDownload', {
    url: '/user/signUpSuccessAndDownload',
    templateUrl: 'user/download.html',
    controller: 'DownloadController'
  })
      .state('forgetPwd', {
        url: '/user/forgetPwd',
        templateUrl: 'user/forgetPwd.html',
        controller: 'UserForgetPwdController',
        resolve:{
          ipInfo: function (IpService) {
            //return IpService.queryIpAddress().then(function(data){
            //  return data;
            //});
            return {query:"192.168.1.1"};

          }
        }
      })
  ;

})
.controller('UserSignInController',
  function ($scope, $stateParams, $location, $ionicPopup, SignService,ipInfo) {


  if(SignService.getUserName() && SignService.getPassword()){
    SignService.signIn(SignService.getUserName(), SignService.getPassword(),ipInfo ? ipInfo.query : "")
    .then(function(data) {
      if (data.status) {
        $location.path("/tab/home");
      }
    });
  }

  $scope.f = {
    action:'signIn',
  }

  $scope.signIn = function(){
    SignService.signIn($scope.f.userName, $scope.f.password,ipInfo ? ipInfo.query : "").then(function(data) {
      if (data.status) {
        $location.path("/tab/home");
      }
    });
  }
})

.controller('UserSignUpController',
  function ($scope, HTTPService, $stateParams, $location,ProductService,SignService,$ionicPopup,VerifyCodeService,$state,ipInfo){

  $scope.isFromWeb = $stateParams.inviter ? true:false;//微信邀请用户注册
  $scope.isShow = true;
  $scope.f = {};

  var showMessage = function (message) {
    return  $ionicPopup.show({

      template: '<label>'+ message +'</label>',
      title: '提示',
      scope: $scope,
      buttons: [
        {
          text: '返回',
          type: 'button-default',
          onTap: function(e) {
            return -1;
          }
        }
      ]
    });
  }

  $scope.toggleShow = function () {
    $scope.isShow = !$scope.isShow;
  }
  $scope.signUp = function  (argument) {
    if($scope.isFromWeb){
      $scope.f.inviter = $stateParams.inviter;
    }
    SignService.signUp($scope.f).then(function(data) {
      if (data.status) {
        if($scope.isFromWeb){
          $state.go("signUpSuccessAndDownload",{});
        }else{
          SignService.signIn($scope.f.userName, $scope.f.password,ipInfo ? ipInfo.query : "").then(function(data) {
            if (data.status) {
              $location.path("/tab/home");
            }
          });
        }
      }
    });
  }
  $scope.getVerifyCode = function () {
    VerifyCodeService.signUpVerifyCode($scope.f.userName).then(function (data) {
      if(data.status){
        showMessage("验证码已经发送到手机,请注意查收.");
      }else{
        showMessage("验证码发送失败.");
      }
    })
  }
})

.controller('UserSignUpDoneController', function ($scope, $http, $stateParams, $location) {

})

.controller('DownloadController', function ($scope, $http, $stateParams, $location) {

})
.controller('UserForgetPwdController', function ($scope, VerifyCodeService,SignService,$location,ipInfo) {
  $scope.isShow = true;
  $scope.f = {};
  $scope.step = 1;

  $scope.canQueryCodeAgain = true;

  $scope.toggleShow = function () {
    $scope.isShow = !$scope.isShow;
  } ;

  var showMessage = function (message) {
    return  $ionicPopup.show({

      template: '<label>'+ message +'</label>',
      title: '提示',
      scope: $scope,
      buttons: [
        {
          text: '返回',
          type: 'button-default',
          onTap: function(e) {
            return -1;
          }
        }
      ]
    });
  }
  $scope.getVerifyCode = function () {
    VerifyCodeService.forgetPasswordVerifyCode($scope.f.userName).then(function (data) {
      if(data.status){
        showMessage("验证码已经发送到手机,请注意查收.");
      }else{
        showMessage("验证码发送失败.");
      }
    })
  }

  $scope.validateCode = function(){
    VerifyCodeService.checkVerifyCodeAction($scope.f.userName,$scope.f.code).then(function (data) {
      if(data.status){
        $scope.step = 2;
      }
    })
  };

  $scope.resetPassword = function() {

    SignService.resetPassword($scope.f.userName,$scope.f.password).then(function(data) {
      if (data.status) {
        SignService.signIn($scope.f.userName, $scope.f.password,ipInfo ? ipInfo.query : "").then(function(data) {
          if (data.status) {
            $location.path("/tab/home");
          }
        });
      }
    });
  };
})

